# ProfileService

> The ProfileService methods and their request and response messages.

Source: https://engramsfactory.com/docs/api/profile/

Generated from [`profile.proto`](https://github.com/cortexapps/engrams/blob/main/crates/engram-protocol/proto/engram/app/v1/profile.proto). Every method is
`POST /rpc/engram.app.v1.ProfileService/<Method>` with a JSON or protobuf body and an
`x-api-key` header.

## Methods

| Method | Request | Response |
|---|---|---|
| `ListProfiles` | [`ListProfilesRequest`](#listprofilesrequest) | [`ListProfilesResponse`](#listprofilesresponse) |
| `GetProfile` | [`GetProfileRequest`](#getprofilerequest) | [`GetProfileResponse`](#getprofileresponse) |
| `CreateProfile` | [`CreateProfileRequest`](#createprofilerequest) | [`CreateProfileResponse`](#createprofileresponse) |
| `UpdateProfile` | [`UpdateProfileRequest`](#updateprofilerequest) | [`UpdateProfileResponse`](#updateprofileresponse) |
| `DiscoverProfileRepos` | [`DiscoverProfileReposRequest`](#discoverprofilereposrequest) | [`DiscoverProfileReposResponse`](#discoverprofilereposresponse) |
| `DeleteProfile` | [`DeleteProfileRequest`](#deleteprofilerequest) | [`DeleteProfileResponse`](#deleteprofileresponse) |

## Messages

### CreateProfileRequest

| Field | Type |
|---|---|
| `name` | `string` |
| `description` | `string` |
| `icon` | `string` |
| `image_id` | `string` |
| `include_user_tokens` | `bool` |
| `env_vars` | `map<string, string>` |
| `skills` | repeated `string` |
| `network` | [`ProfileNetwork`](#profilenetwork) |
| `secrets` | repeated [`ProfileSecret`](#profilesecret) |
| `harness` | `string` (optional) |
| `model` | `string` (optional) |
| `effort` | `string` (optional) |
| `integration_grants` | repeated [`ProfileIntegrationGrant`](#profileintegrationgrant) |
| `repos` | repeated [`ProfileRepo`](#profilerepo) |
| `model_router` | `string` (optional) |
| `apps` | repeated [`SessionApp`](#sessionapp) |
| `programmatic_only` | `bool` |

### CreateProfileResponse

| Field | Type |
|---|---|
| `profile` | [`Profile`](#profile) |

### DeleteProfileRequest

| Field | Type |
|---|---|
| `id` | `string` |

### DeleteProfileResponse

No fields.

### DiscoveredRemote

| Field | Type |
|---|---|
| `name` | `string` |
| `url` | `string` |
| `parsed` | [`ProfileRepoRemote`](#profilereporemote) (optional) |

### DiscoveredRepo

| Field | Type |
|---|---|
| `path` | `string` |
| `remotes` | repeated [`DiscoveredRemote`](#discoveredremote) |

### DiscoverProfileReposRequest

| Field | Type |
|---|---|
| `profile_id` | `string` |

### DiscoverProfileReposResponse

| Field | Type |
|---|---|
| `repos` | repeated [`DiscoveredRepo`](#discoveredrepo) |

### GetProfileRequest

| Field | Type |
|---|---|
| `id` | `string` |

### GetProfileResponse

| Field | Type |
|---|---|
| `profile` | [`Profile`](#profile) |

### ListProfilesRequest

| Field | Type |
|---|---|
| `include_archived` | `bool` |
| `for_session_picker` | `bool` |

### ListProfilesResponse

| Field | Type |
|---|---|
| `profiles` | repeated [`Profile`](#profile) |

### Profile

| Field | Type |
|---|---|
| `id` | `string` |
| `name` | `string` |
| `description` | `string` |
| `icon` | `string` |
| `image_id` | `string` |
| `include_user_tokens` | `bool` |
| `env_vars` | `map<string, string>` |
| `archived` | `bool` |
| `created_at` | `string` |
| `updated_at` | `string` |
| `skills` | repeated `string` |
| `network` | [`ProfileNetwork`](#profilenetwork) |
| `secrets` | repeated [`ProfileSecret`](#profilesecret) |
| `harness` | `string` (optional) |
| `model` | `string` (optional) |
| `effort` | `string` (optional) |
| `integration_grants` | repeated [`ProfileIntegrationGrant`](#profileintegrationgrant) |
| `repos` | repeated [`ProfileRepo`](#profilerepo) |
| `model_router` | `string` (optional) |
| `apps` | repeated [`SessionApp`](#sessionapp) |
| `programmatic_only` | `bool` |

### ProfileIntegrationGrant

| Field | Type |
|---|---|
| `connection_id` | `string` |
| `operation` | `string` |
| `resource_constraints` | repeated `string` |
| `credential_scope` | `string` |

### ProfileNetwork

| Field | Type |
|---|---|
| `default` | `string` |
| `allow_hosts` | repeated `string` |
| `allow_host_patterns` | repeated `string` |

### ProfileRepo

| Field | Type |
|---|---|
| `path` | `string` |
| `remote_url` | `string` |
| `remote` | [`ProfileRepoRemote`](#profilereporemote) (optional) |

### ProfileRepoRemote

| Field | Type |
|---|---|
| `host` | `string` |
| `owner` | `string` |
| `name` | `string` |

### ProfileSecret

| Field | Type |
|---|---|
| `ref` | `string` |
| `env_var` | `string` |
| `mode` | `string` |
| `allow_hosts` | repeated `string` |
| `allow_host_patterns` | repeated `string` |

### SessionApp

| Field | Type |
|---|---|
| `name` | `string` |
| `port` | `uint32` |

### UpdateProfileRequest

| Field | Type |
|---|---|
| `id` | `string` |
| `name` | `string` |
| `description` | `string` |
| `icon` | `string` |
| `image_id` | `string` |
| `include_user_tokens` | `bool` |
| `env_vars` | `map<string, string>` |
| `skills` | repeated `string` |
| `network` | [`ProfileNetwork`](#profilenetwork) |
| `secrets` | repeated [`ProfileSecret`](#profilesecret) |
| `harness` | `string` (optional) |
| `model` | `string` (optional) |
| `effort` | `string` (optional) |
| `integration_grants` | repeated [`ProfileIntegrationGrant`](#profileintegrationgrant) |
| `repos` | repeated [`ProfileRepo`](#profilerepo) |
| `model_router` | `string` (optional) |
| `apps` | repeated [`SessionApp`](#sessionapp) |
| `programmatic_only` | `bool` (optional) |

### UpdateProfileResponse

| Field | Type |
|---|---|
| `profile` | [`Profile`](#profile) |
